#!/usr/bin/env node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = __importDefault(require("@auto-it/core"));
function run(command, args) {
    return __awaiter(this, void 0, void 0, function () {
        var auto, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    auto = new core_1.default(args);
                    _a = command;
                    switch (_a) {
                        case 'init': return [3 /*break*/, 1];
                        case 'create-labels': return [3 /*break*/, 3];
                        case 'label': return [3 /*break*/, 6];
                        case 'pr-check': return [3 /*break*/, 9];
                        case 'pr-status': return [3 /*break*/, 12];
                        case 'comment': return [3 /*break*/, 15];
                        case 'pr-body': return [3 /*break*/, 18];
                        case 'version': return [3 /*break*/, 21];
                        case 'changelog': return [3 /*break*/, 24];
                        case 'release': return [3 /*break*/, 27];
                        case 'shipit': return [3 /*break*/, 30];
                        case 'canary': return [3 /*break*/, 33];
                    }
                    return [3 /*break*/, 36];
                case 1: return [4 /*yield*/, auto.init(args)];
                case 2:
                    _b.sent();
                    return [3 /*break*/, 37];
                case 3: return [4 /*yield*/, auto.loadConfig()];
                case 4:
                    _b.sent();
                    return [4 /*yield*/, auto.createLabels(args)];
                case 5:
                    _b.sent();
                    return [3 /*break*/, 37];
                case 6: return [4 /*yield*/, auto.loadConfig()];
                case 7:
                    _b.sent();
                    return [4 /*yield*/, auto.label(args)];
                case 8:
                    _b.sent();
                    return [3 /*break*/, 37];
                case 9: return [4 /*yield*/, auto.loadConfig()];
                case 10:
                    _b.sent();
                    return [4 /*yield*/, auto.prCheck(args)];
                case 11:
                    _b.sent();
                    return [3 /*break*/, 37];
                case 12: return [4 /*yield*/, auto.loadConfig()];
                case 13:
                    _b.sent();
                    return [4 /*yield*/, auto.prStatus(args)];
                case 14:
                    _b.sent();
                    return [3 /*break*/, 37];
                case 15: return [4 /*yield*/, auto.loadConfig()];
                case 16:
                    _b.sent();
                    return [4 /*yield*/, auto.comment(args)];
                case 17:
                    _b.sent();
                    return [3 /*break*/, 37];
                case 18: return [4 /*yield*/, auto.loadConfig()];
                case 19:
                    _b.sent();
                    return [4 /*yield*/, auto.prBody(args)];
                case 20:
                    _b.sent();
                    return [3 /*break*/, 37];
                case 21: return [4 /*yield*/, auto.loadConfig()];
                case 22:
                    _b.sent();
                    return [4 /*yield*/, auto.version(args)];
                case 23:
                    _b.sent();
                    return [3 /*break*/, 37];
                case 24: return [4 /*yield*/, auto.loadConfig()];
                case 25:
                    _b.sent();
                    return [4 /*yield*/, auto.changelog(args)];
                case 26:
                    _b.sent();
                    return [3 /*break*/, 37];
                case 27: return [4 /*yield*/, auto.loadConfig()];
                case 28:
                    _b.sent();
                    return [4 /*yield*/, auto.runRelease(args)];
                case 29:
                    _b.sent();
                    return [3 /*break*/, 37];
                case 30: return [4 /*yield*/, auto.loadConfig()];
                case 31:
                    _b.sent();
                    return [4 /*yield*/, auto.shipit(args)];
                case 32:
                    _b.sent();
                    return [3 /*break*/, 37];
                case 33: return [4 /*yield*/, auto.loadConfig()];
                case 34:
                    _b.sent();
                    return [4 /*yield*/, auto.canary(args)];
                case 35:
                    _b.sent();
                    return [3 /*break*/, 37];
                case 36: throw new Error("idk what i'm doing.");
                case 37: return [2 /*return*/];
            }
        });
    });
}
exports.run = run;
function main(command, args) {
    return __awaiter(this, void 0, void 0, function () {
        var error_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, run(command, args)];
                case 1:
                    _a.sent();
                    return [3 /*break*/, 3];
                case 2:
                    error_1 = _a.sent();
                    if (error_1) {
                        console.log(error_1);
                        process.exit(1);
                    }
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    });
}
exports.default = main;
//# sourceMappingURL=run.js.map